/*
 : min_p_for_given_t[k][i][p] --
       
 i-  ,   i-  
  (k==0 -- , k==1 -- ) 
         
    p.
    ' 
 S,T<=10^5,     '
(1e+16 ,   
      100--500 ).

    , 
    
   0  \approx 1e+5.

     
 ,   
~   . 
      , ,     .
*/

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

typedef long long ll;

const int MAXN = 40;
const int MAXVALUE_const = (1 << 20) - 1;
int MAXVALUE = MAXVALUE_const;
int MAXVALUEPROD = 3003003;

ll 
min_p_for_given_t[2][2][MAXVALUE_const+1], 
min_t_for_given_p[2][2][MAXVALUE_const+1];

struct segm
{
	ll tfree, tpaid, pay, tchange;
} data[MAXN];

int N;
ll MAX_T, MAX_P;

void ReadData(void)
{
	ll waste;
	ifstream fin("highway.dat");
	fin >> N >> MAX_T >> MAX_P;
	data[0].tchange = 0LL;
	fin >> data[0].tfree >> data[0].tpaid >> data[0].pay;
	for(int i=1; i<N; i++)
		fin >> data[i].tchange >> data[i].tfree >> data[i].tpaid >> data[i].pay;

	MAXVALUE = min(MAXVALUE, MAXVALUEPROD/N);
}

const ll INFTY = 0x0606060606060606LL;
const ll INFTY_2 = 132011201120112011LL;

ll _min_p_ = INFTY , _min_t_ = INFTY;
ll SCALE_DIVISOR_TIME, SCALE_DIVISOR_PAY;

int scale_t_round(ll val) {return (int)((val + SCALE_DIVISOR_TIME/2) / SCALE_DIVISOR_TIME);};
int scale_p_round(ll val) {return (int)((val + SCALE_DIVISOR_PAY/2) / SCALE_DIVISOR_PAY);};

template<class T> inline void change_for_less(T &a, T b)
{
	if(b < a)
		a = b;
}

ll calc_min_p_for_given_t(ll dp[2][2][MAXVALUE_const+1], int how_scale(ll), int MAX_T_SCALED)
{
	{ //   --        (N-1)- 
		int i_mod_2 = (N-1)% 2;
		memset(dp[0][i_mod_2], 0x06, sizeof(ll)*(MAX_T_SCALED+1));
		memset(dp[1][i_mod_2], 0x06, sizeof(ll)*(MAX_T_SCALED+1));
		for(int ttt = how_scale(data[N-1].tfree); ttt <= MAX_T_SCALED; ttt++)
			dp[0][i_mod_2][ttt] = 0;
		for(int ttt = how_scale(data[N-1].tpaid); ttt <= MAX_T_SCALED; ttt++)
			dp[1][i_mod_2][ttt] = data[N-1].pay;
	}
	for(signed i = N-2; i>=0; i--)
	{
		int i_mod_2 = i%2, i_another = (i+1)%2;
		int dt_freefree = how_scale(data[i].tfree);
		int dt_freepaid = how_scale(data[i].tfree + data[i+1].tchange);
		int dt_paidfree = how_scale(data[i].tpaid + data[i+1].tchange);
		int dt_paidpaid = how_scale(data[i].tpaid);
		for(int ttt = 0; ttt <= MAX_T_SCALED; ttt++)
		{
			dp[0][i_mod_2][ttt] = INFTY;
			dp[1][i_mod_2][ttt] = INFTY;
			if(ttt>=dt_freefree)
				change_for_less(dp[0][i_mod_2][ttt], dp[0][i_another][ttt - dt_freefree]); // + 0
			if(ttt>=dt_freepaid)
				change_for_less(dp[0][i_mod_2][ttt], dp[1][i_another][ttt - dt_freepaid]); // + 0
			if(ttt>=dt_paidfree)
				change_for_less(dp[1][i_mod_2][ttt], dp[0][i_another][ttt - dt_paidfree] + data[i].pay);
			if(ttt>=dt_paidpaid)
				change_for_less(dp[1][i_mod_2][ttt], dp[1][i_another][ttt - dt_paidpaid] + data[i].pay);
		}
	}
	ll res = min(dp[0][0][MAX_T_SCALED], dp[1][0][MAX_T_SCALED]);
	if(res == INFTY)
		res = -1LL;
	return res;
}

ll calc_min_t_for_given_p(ll dp[2][2][MAXVALUE_const+1], int how_scale(ll), int MAX_P_SCALED)
{
	{ //   --        (N-1)- 
		int i_mod_2 = (N-1)% 2;
		memset(dp[1][i_mod_2], 0x06, sizeof(ll)*(MAX_P_SCALED+1));
		for(int ppp = 0; ppp <= MAX_P_SCALED; ppp++)
			dp[0][i_mod_2][ppp] = data[N-1].tfree;
		for(int ppp = how_scale(data[N-1].pay); ppp <= MAX_P_SCALED; ppp++)
			dp[1][i_mod_2][ppp] = data[N-1].tpaid;
	}
	for(signed i = N-2; i>=0; i--)
	{
		int i_mod_2 = i%2, i_another = (i+1)%2;
		ll t_freefree = data[i].tfree;
		ll t_freepaid = data[i].tfree + data[i+1].tchange;
		ll t_paidfree = data[i].tpaid + data[i+1].tchange;
		ll t_paidpaid = data[i].tpaid;
		int curr_pay = how_scale(data[i].pay);
		for(int ppp = 0; ppp <= MAX_P_SCALED; ppp++)
		{
			dp[0][i_mod_2][ppp] = min(dp[0][i_another][ppp] + t_freefree, dp[1][i_another][ppp] + t_freepaid);
			if(ppp<curr_pay)
				dp[1][i_mod_2][ppp] = INFTY;
			else
				dp[1][i_mod_2][ppp] = min(
				dp[0][i_another][ppp - curr_pay] + t_paidfree, 
				dp[1][i_another][ppp - curr_pay] + t_paidpaid);
		}
	}
	ll res = min(dp[0][0][MAX_P_SCALED], dp[1][0][MAX_P_SCALED]);
	if(res == INFTY)
		res = -1LL;
	return res;
}
 
int main(int argc, char* argv[])
{
	ReadData();
	SCALE_DIVISOR_TIME = (MAX_T + MAXVALUE - 1) / (MAXVALUE);
	_min_p_ = calc_min_p_for_given_t(min_p_for_given_t, scale_t_round, scale_t_round(MAX_T));
	SCALE_DIVISOR_PAY = (MAX_P + MAXVALUE - 1) / (MAXVALUE);
	_min_t_ = calc_min_t_for_given_p(min_t_for_given_p, scale_p_round, scale_p_round(MAX_P));
	ofstream fout("highway.sol");
	fout << _min_p_ << " " << _min_t_ << endl;
	return 0;
}
