{
	  '
}

program trjam_pas_again;

{$mode delphi}

const MAXN = 40;
      MAXL = 1 shl ((MAXN-1)div 2);

type TSegm = record
       tfree, tpaid : int64;
       pay : int64;
       tchange : int64;
     end;
     ASegm = array[1..MAXN] of TSegm;

var N, N_1, N_2 : byte;
    segm : ASegm;
    MAX_T, MAX_P : int64;

procedure ReadData;
var fv : text;
    i : byte;
Begin
  assign(fv, 'highway.dat'); reset(fv);
  read(fv, N, MAX_T, MAX_P);
  read(fv, segm[1].tfree, segm[1].tpaid, segm[1].pay);
  for i:=2 to N do
    read(fv, segm[i-1].tchange, segm[i].tfree, segm[i].tpaid, segm[i].pay);
  close(fv);
  N_1 := N div 2;
  N_2 := N - N_1;
  for i:=N-1 downto N_1 do
    segm[i+1].tchange := segm[i].tchange;
End;

procedure reverse(var a : ASegm; N : byte);
var i, j : byte;
    tmp : TSegm;
Begin
  i:=1; j:=N;
  while i<j do begin
    tmp := a[i]; a[i] := a[j]; a[j] := tmp;
    inc(i); dec(j);
  end;
End;

type opt_pair = record
       p, t : int64;
     end;
     arr_pairs = array[1..MAXL] of opt_pair;
     AllHalf = record
       free, paid : arr_pairs;
       free_used, paid_used : integer;
     end;

var left, right : AllHalf;
    the_halfs : array[0..1] of AllHalf;

procedure one_spec_merge(const free, paid : arr_pairs;
                          free_used, paid_used : integer;
                          t_curr, t_change_from_free, t_change_from_paid, pay_curr : int64;
                          var res : arr_pairs; var res_used : integer);
var i_free_in, i_paid_in, i_out : integer;
    curr_free, curr_paid : opt_pair;
Begin
  i_free_in:=1; i_paid_in:=1; i_out:=0;
  curr_free.t := free[1].t + t_change_from_free + t_curr;
  curr_free.p := free[1].p + pay_curr;
  curr_paid.t := paid[1].t + t_change_from_paid + t_curr;
  curr_paid.p := paid[1].p + pay_curr;
  while (i_free_in<=free_used) and (i_paid_in<=paid_used) do begin
    if (curr_free.p < curr_paid.p) or (curr_free.p = curr_paid.p)and(curr_free.t < curr_paid.t) then begin //    ,        curr_free.p <= curr_paid.p
      if (i_out = 0) or (curr_free.t < res[i_out].t) then begin
        inc(i_out); res[i_out] := curr_free;
      end;
      inc(i_free_in);
      curr_free.t := free[i_free_in].t + t_change_from_free + t_curr;
      curr_free.p := free[i_free_in].p + pay_curr;
    end else begin
      if (i_out = 0) or (curr_paid.t < res[i_out].t) then begin
        inc(i_out); res[i_out] := curr_paid;
      end;
      inc(i_paid_in);
      curr_paid.t := paid[i_paid_in].t + t_change_from_paid + t_curr;
      curr_paid.p := paid[i_paid_in].p + pay_curr;
    end;
  end;
  while (i_free_in<=free_used) do begin
    if {(i_out = 0) or }(curr_free.t < res[i_out].t) then begin
      inc(i_out); res[i_out] := curr_free;
    end;
    inc(i_free_in);
    curr_free.t := free[i_free_in].t + t_change_from_free + t_curr;
    curr_free.p := free[i_free_in].p + pay_curr;
  end;
  while (i_paid_in<=paid_used) do begin
    if {(i_out = 0) or }(curr_paid.t < res[i_out].t) then begin
      inc(i_out); res[i_out] := curr_paid;
    end;
    inc(i_paid_in);
    curr_paid.t := paid[i_paid_in].t + t_change_from_paid + t_curr;
    curr_paid.p := paid[i_paid_in].p + pay_curr;
  end;
  res_used := i_out;
End;

procedure GenHalf(var what_half : AllHalf; N_ : byte);
var idx : byte;
Begin
  the_halfs[1].free_used:=1;
  the_halfs[1].free[1].p := 0;
  the_halfs[1].free[1].t := segm[1].tfree;
  the_halfs[1].paid_used:=1;
  the_halfs[1].paid[1].p := segm[1].pay;
  the_halfs[1].paid[1].t := segm[1].tpaid;
  for idx := 2 to N_ do begin
    one_spec_merge(the_halfs[(idx-1)mod 2].free, the_halfs[(idx-1)mod 2].paid,
        the_halfs[(idx-1)mod 2].free_used, the_halfs[(idx-1)mod 2].paid_used,
        segm[idx].tfree,    0, segm[idx-1].tchange,          0,
        the_halfs[idx mod 2].free, the_halfs[idx mod 2].free_used);
    one_spec_merge(the_halfs[(idx-1)mod 2].free, the_halfs[(idx-1)mod 2].paid,
        the_halfs[(idx-1)mod 2].free_used, the_halfs[(idx-1)mod 2].paid_used,
        segm[idx].tpaid, segm[idx-1].tchange, 0, segm[idx].pay,
        the_halfs[idx mod 2].paid, the_halfs[idx mod 2].paid_used);
  end;
  what_half := the_halfs[N_ mod 2];
End;

const INFTY = 132011201120112011;

function min(x, y : int64) : int64;
Begin
  if x < y then
    min := x
  else
    min := y
End;

function one_case_min_p_at_t(const left_, right_ : arr_pairs; left_used, right_used : integer; MAX_T__ : int64) : int64;
var i, j : integer;
    curr_p, res_p : int64;
Begin
  res_p := INFTY;
  j:=right_used;
  for i:=1 to left_used do begin
    while (j>1) and (left_[i].t + right_[j-1].t <= MAX_T__) do
      dec(j);
    if (left_[i].t + right_[j].t <= MAX_T__) then begin
      curr_p := left_[i].p + right_[j].p;
      if curr_p < res_p then
        res_p := curr_p;
    end;
  end;
  Result := res_p;
End;

function solve_min_p_at_given_t : int64;
Begin
  Result := INFTY;
  Result := min(Result, one_case_min_p_at_t(left.free, right.free, left.free_used, right.free_used, MAX_T));
  Result := min(Result, one_case_min_p_at_t(left.free, right.paid, left.free_used, right.paid_used, MAX_T - segm[N_1].tchange));
  Result := min(Result, one_case_min_p_at_t(left.paid, right.free, left.paid_used, right.free_used, MAX_T - segm[N_1].tchange));
  Result := min(Result, one_case_min_p_at_t(left.paid, right.paid, left.paid_used, right.paid_used, MAX_T));
  if Result = INFTY then Result := -1;
End;

function one_case_min_t_at_p(const left_, right_ : arr_pairs; left_used, right_used : integer; MAX_P__ : int64) : int64;
var i, j : integer;
    curr_t, res_t : int64;
Begin
  res_t := INFTY;
  j:=1;
  for i:=left_used downto 1 do begin
    while (j<right_used) and (left_[i].p + right_[j+1].p <= MAX_P__) do
      inc(j);
    if (left_[i].p + right_[j].p <= MAX_P__) then begin
      curr_t := left_[i].t + right_[j].t;
      if curr_t < res_t then
        res_t := curr_t;
    end;
  end;
  Result := res_t;
End;

function solve_min_t_at_given_p : int64;
Begin
  Result := INFTY;
  Result := min(Result, one_case_min_t_at_p(left.free, right.free, left.free_used, right.free_used, MAX_P));
  Result := min(Result, one_case_min_t_at_p(left.free, right.paid, left.free_used, right.paid_used, MAX_P) + segm[N_1].tchange);
  Result := min(Result, one_case_min_t_at_p(left.paid, right.free, left.paid_used, right.free_used, MAX_P) + segm[N_1].tchange);
  Result := min(Result, one_case_min_t_at_p(left.paid, right.paid, left.paid_used, right.paid_used, MAX_P));
//  if Result = INFTY then Result := -1;
End;

var _min_p_, _min_t_ : int64;
    fv : text;

BEGIN
  ReadData;
  GenHalf(left, N_1);
  reverse(segm, N);
  GenHalf(right, N_2);
  reverse(segm, N);

  _min_p_ := solve_min_p_at_given_t;
  _min_t_ := solve_min_t_at_given_p;

  assign(fv, 'highway.sol'); rewrite(fv);
  writeln(fv, _min_p_, ' ', _min_t_);
  close(fv);
END.
